"use strict";
this.name        = "carriers";
this.author      = "Norby";
this.copyright   = "2014 Norbert Nagy";
this.licence     = "CC BY-NC-SA 4.0";
this.description = "Carriers with open decks.";

//internal properties, should not touch
this.$CarriersBG = ""; //backgroung image for missionscreens of Carriers
this.$CarriersCarrier = null; //the carrier ship object, used in carriers-escort.js ship script
this.$CarriersDocked = false; //flag if the player is the current ship is a carrier when player is docked
this.$CarriersED = null; //store a pointer to escortdeck worldscript
this.$CarriersEDCarrierPad = -1; //this pad on Escort Deck store the Carrier when player sit into an escort
this.$CarriersLastShip = null; //store the last player ship which is docked into a station for detect restore
this.$CarriersLeavedEscortData = []; //store escort data when sit back into the Carrier
this.$CarriersPirate = null; //store a created pirate carrier
this.$CarriersPlayerInEscort = false; //flag for EscortDeck FCB
this.$CarriersPrevCarrier = null; //save last name to avoid repeated landing clearance message
this.$CarriersS = null; //store the created trader ship to prevent recreates
this.$CarriersShip = null; //store the created trader ship to prevent recreates
this.$CarriersShipStorage = []; //store the carried escort ships, the 0. position store the carrier itself
this.$CarriersSH = null; //store a pointer to Ship_Storage_Helper.js worldscript
this.$CarriersSV = null; //store a pointer to shipversion worldscript
this.$CarriersSVB = null; //store the whole playerBoughtNewShip() code of shipversion
this.$CarriersT = null; //store a pointer to telescope worldscript
this.$CarriersSitInto = false; //flag to sit into the Carrier
this.$CarriersSitInto2 = false; //flag for message after sit into the Carrier
this.$CarriersTimer = null;
this.$CarriersVDock = null; //Virtual dock for ship change during launch an escort from the carrier
this.$CarriersVDockIn = false; //flag for timer to dock the player into vdock
this.$EscortDeckLandingDist = 500; //landing distance, will be overwritten if EscortDeck OXP present

//world script events
this.startUp = function() {
	if(worldScripts["BGS-M"]) this.$CarriersBG = "bgs-i_equipship.png";
	else if(worldScripts["Better Screens"]) this.$CarriersBG = "bs-base-bg.png";
	else if(worldScripts["Gallery"]) this.$CarriersBG = "gallery_bg.png";
	
	this.$CarriersTimer = new Timer(this, this.$Carriers_Timed.bind(this), 2, 2);
	this.$CarriersSitInto = false;
	this.$CarriersSitInto2 = false;
	this.$CarriersED = worldScripts.escortdeck;
	if(!this.$CarriersED) log("Carriers", "Error: Carriers can not handle escorts without EscortDeck OXP");
	else this.$EscortDeckLandingDist = this.$CarriersED.$EscortDeckLandingDist;
	
	this.$CarriersSH = worldScripts["Ship_Storage_Helper.js"];
	if(!this.$CarriersSH) log("Carriers", "Error: Carriers can not change ship without Ship Storage Helper OXP");
	else {
//		player.credits += 1000000;//debug ;)
	}
	this.$CarriersSV = worldScripts.shipversion;
	this.$CarriersT = worldScripts.telescope;

	var s = missionVariables.$CarriersShipStorage;
	if( s && s.length > 0 )	this.$CarriersShipStorage = JSON.parse(s);

	this.$CarriersVDock = null; //Virtual dock for ship change during launch an escort from the carrier
	this.$CarriersEDCarrierPad = -1; //this pad store the Carrier when player sit into an escort
	this.$CarriersPlayerInEscort = false;

	this.$Carriers_CheckCarrier();
}

this.guiScreenChanged = function(to, from) {
	var ps = player.ship;
	var w = this.$CarriersED;
	if( to != "GUI_SCREEN_STATUS" || !ps.docked ) return;
	log("Carriers", "guiScreenChanged "+to+" docked:"+ps.docked+" "+ps.dockedStation+" "
		+this.$CarriersSitInto+" vdock:"+this.$CarriersVDock);
	if( !w || !this.$CarriersVDock ) return;
	if( this.$CarriersSitInto ) { //sit into the carrier
		this.$CarriersSitInto = false;
		player.consoleMessage("Welcome home, Commander "+player.name+"!", 5);
//		this.$CarriersVDock.remove(true);
//		this.$CarriersVDock = null;
//		this.$Carriers_SitIntoTheCarrier();
//		ps.launch();
//		w.$EscortDeck_PutShip(w.$CarriersLastShip, this.$CarriersEDCarrierPad
//				      pad, ps, w, false, true );//land escort
		this.$CarriersEDCarrierPad = -1;
		this.$CarriersPlayerInEscort = false;
		this.$CarriersSitInto2 = true;
		if( ps.equipmentStatus("EQ_ESCORTDECKXL") == "EQUIPMENT_OK" )
			ps.removeEquipment("EQ_ESCORTDECK"); //bugfix
		return;
	} else { //launch player in an escort
		//this pad on Escort Deck store the Carrier when player sit into an escort
		var pad = w.$EscortDeckSelectedPad;
		this.$CarriersEDCarrierPad = pad;

		var eq = "EQ_ESCORTDECK";
		if( ps.equipmentStatus("EQ_ESCORTDECKXL") == "EQUIPMENT_OK" )
			eq = "EQ_ESCORTDECKXL"; //save the current deck equipment

		var s = JSON.stringify(w.$EscortDeckShipData[pad]);
		if( s && s.length > 0 ) {
			this.$CarriersCarrier = ps;
			if(ps.script) ps.script.$EscortDeckUsable = 1; //carrier is always usable
			this.$CarriersShipStorage[0] = this.$Carriers_StoreShip(); //save the carrier
			if( w.$EscortDeckShip[pad] && w.$EscortDeckShip[pad].isValid )
				w.$EscortDeckShip[pad].remove(true);//remove NPC escort
			w.$EscortDeckShipData[pad] = null; //prevent recreation in dock
			w.$EscortDeckShipPos[pad] = null; //do not update position in FCB
			this.$CarriersPlayerInEscort = true;
//			log("Carriers","Stored: "+this.$CarriersShipStorage[0]);
			if( !this.$Carriers_RestoreShip(s, true) ) {
				log("Carriers","Error: can not sit into "+s);
				this.$CarriersPlayerInEscort = false;
				this.$CarriersSitInto = true;
				this.guiScreenChanged(to, from); //sit back into the carrier and launch
				return; //failed to sit into the escort
			}
		} else return;
		log("Carriers", "Player ship changed to pad "+pad+": "+s);

		ps.awardEquipment(eq); //Escort Deck or XL deck for using MFD and primable functions
//		ps.launch(); //must leave the dock immediately to avoid safety on an open deck
		this.$CarriersSitInto2 = true;

		var c = null; //spawn the carrier behind the player after takeoff
		var pos = this.$CarriersVDock.position.add(this.$CarriersVDock.heading
			.multiply(-(this.$EscortDeckLandingDist-100)));
//		this.$CarriersVDock.remove(true);
//		this.$CarriersVDock = null;
		var b = JSON.parse(this.$CarriersShipStorage[0]); // destringify the carrier
		if( b.length > 1 && b[1].length > 0 ) //b[1] is the stored dataKey of carrier
			c = system.addShips("["+b[1]+"]", 1, pos, 10);
		if( c && c[0] && c[0].isValid ) {
			w.$EscortDeck_RestoreShipData(c[0], b, w);
			if(c[0].addCollisionException) { //from v1.81
				for(var i = 0; i < w.$EscortDeckPadPos.length; i++ ) {
					if( w.$EscortDeckShip && w.$EscortDeckShip[i] )
						c[0].addCollisionException(w.$EscortDeckShip[i]);
				}
			}
			w.$EscortDeckShip[pad] = c[0]; //replace the escort with the Carrier in MFD
			this.$Carriers_EscortSetup(c[0], 0); //give AI to the npc carrier
			this.$CarriersCarrier = c[0];
			
		} else log("Carriers","Error: can not create Carrier at escort takeoff");
		log("Carriers","b:"+b+" c:"+c);
		
		var m = worldScripts.combat_MFD;
		if( m ) m.shipWillLaunchFromStation.bind(m); //start timer for update
	}
}

this.playerWillSaveGame = function(message) {
       missionVariables.$CarriersShipStorage = JSON.stringify(this.$CarriersShipStorage);
}

this.shipAttackedOther = function(other) { //player hits other
	if( !other.script ) other.script = "oolite-default-ship-script.js"; //for sure
	if( other.script ) other.script.$Carriers_Target = 1; //flag for carrier AI
}

this.shipCollided = function( pt ) {
	if( pt && pt.isValid && pt == this.$CarriersCarrier //exclude carriers in exhibitions of Gallery OXP
		&& player.ship && player.ship.isValid && player.ship.target == pt ) {
		this.$Carriers_DockPlayer( pt );
	}
}

this.shipDockedWithStation = function(station) {
//	var ps = player.ship;
//	log("Carriers", "sDWS station.dataKey:"+station.dataKey+" ps.dockedStation:"
//		+ps.dockedStation+" sitinto:"+this.$CarriersSitInto+" vdock:"+this.$CarriersVDock);
//	var w = this.$CarriersED;
//	if( !ps.dockedStation || !ps.dockedStation.dataKey
//		|| ps.dockedStation.dataKey.indexOf("carrier") == -1 ) return;
	if( this.$CarriersSitInto ) { //player is landing into the carrier
//		player.consoleMessage( ps.displayName+" is landing on "+this.$CarriersSitInto.displayName, 10 );
		this.$Carriers_SitIntoTheCarrier();
	}
}

this.shipLaunchedFromStation = function() {
	if( this.$CarriersVDock ) {
		this.$CarriersVDock.remove(true);
		this.$CarriersVDock = null;
	}
}

this.shipTargetAcquired = function(target) {
	this.$CarriersPrevCarrier = null; //to get landing clearance message a bit later
}

this.shipWillDockWithStation = function() {
	this.$Carriers_CheckCarrier();
}

//Carriers functions
this.$Carriers_CheckCarrier = function() {
	var ws = worldScripts["carriers"];
	var ps = player.ship;
	if( ps && ps.isValid && ps.dataKey && ps.dataKey.indexOf("carrier-player") > -1 ) { //current ship is a carrier
		ws.$CarriersDocked = true;
		ws.$CarriersCarrier = ps;
		ws.$CarriersShipStorage[0] = ws.$Carriers_StoreShip(); //save the carrier
	} else ws.$CarriersDocked = false;
}

this.$Carriers_DockPlayer = function( pt ) {
	var ws = worldScripts.carriers;
	//check speed difference
	var diff = player.ship.velocity.subtract( pt.velocity ).magnitude();
	if( diff > 100 ) {
		player.consoleMessage(Math.round(diff)+" m/s speed difference deny landing on "
			+ws.$CarriersPrevCarrier, 5);
	} else {
		var ps = player.ship;
		var w = ws.$CarriersED;
		ws.$CarriersSitInto = true;
		ws.$CarriersSitInto2 = false;
		var pos = pt.position.add(pt.vectorForward.multiply(1000));
		ws.$CarriersVDock = system.addShips("[carriers-vdock]", 1, pos, 100)[0];
		if( w && ws.$CarriersVDock ) {
			ws.$CarriersVDock.orientation = pt.orientation; //the direction of launch
			if(ps.addCollisionException)  //from v1.81
				ps.addCollisionException(ws.$CarriersVDock);
			ws.$CarriersVDockIn = true; //timer will dock the player into vdock
			ws.$CarriersVDock.dockPlayer(); //if you comment out this line
//			ws.$CarriersLeavedEscortData = w.$EscortDeck_MakeShipData(player.ship);
			//continued in this.guiScreenChanged
		} else log("Carriers", "Error: can not create virtual dock for sit into the carrier");
	}
}

this.$Carriers_EscortSetup = function( e, id ) {
	var ws = worldScripts.carriers;
	var w = ws.$CarriersED;
	var ai = "interceptAI.plist"; //fallback ai if no escortdeck oxp present
	if( w ) ai = "EscortDeck_AI.plist";

	var ps = player.ship;
	if( e && e.isValid ) {
		if(!ps.group) ps.group = new ShipGroup("CarriersEscorts", ps); //player ship is the leader
		ps.group.addShip(e);
		e.switchAI(ai);
		if( w ) e.AIState = ("GOTO");
		e.scannerDisplayColor1 = [0.3, 1, 0.3]; //lightgreen
		var usable = 0;
		var sl = 0;
		if(e.script) {
			usable = e.script.$EscortDeckUsable; //must set again after setScript
			sl = e.script.$SSH_serviceLevel; //must set again after setScript
		}
		if( w ) e.setScript("escortdeck_escort.js");
		if(e.script) {
			e.script.$CarriersEscortHome = ws.$CarriersCarrier; //set the owner carrier
			e.script.$CarriersShipStorageID = id; //position in $CarriersShipStorage array
			e.script.$EscortDeckUsable = usable;
			e.script.$SSH_serviceLevel = sl;
		}
		e.orientation = ps.orientation;
	} else log("Carriers","Error: can not setup escort #"+id+" "+e);
}
			
this.$Carriers_RestoreShip = function(storedShipString, escort) {
	var ws = worldScripts["carriers"];
	if(ws.$CarriersSH) {
		var h = worldScripts.hudselector;
		if( h ) h.$HUDSelectorRestoreHUD(); //give back the actual HUD
		if( escort ) {
			var d = JSON.parse(storedShipString);
//			log("Carriers", "d1:"+d[1] " d13:"+d[13] " d:"+d);
			if( !player.replaceShip(d[1],d[13]) ) return false;
			var w = ws.$CarriersED;
			if( w ) w.$EscortDeck_RestoreShipData(player.ship, d, w);
			log("Carriers", "new player.ship: "+player.ship);
		} else {
			var e = ws.$CarriersSH.restoreStoredShip(storedShipString); //carrier
			log("Carriers", "player.ship: "+player.ship+" e:"+e);
			if( e && e.length > 1 ) return false;
		}
//		if( ws.$CarriersVDock ) { //put back NumHUD eqipments and start refresh timers
//			var nh = worldScripts["numerichudv3"];
//			if( nh ) nh.shipWillLaunchFromStation();
//		}
		
//		log("Carriers", "player.ship.maxEscorts: "+player.ship.maxEscorts);
		//player.ship.maxEscorts= 16; //16 is the maximum allowed by the core game - but read only
		return true;
	} else log("Carriers", "Error: Carriers can not restore ship without Ship Storage Helper OXP");
	return false;
}

this.$Carriers_SitIntoAnEscort = function(ship) { //called from EscortDeck's EQActivated
	var ps = player.ship;
	var ws = worldScripts.carriers;
	var pos = ps.position.add(ps.vectorForward.multiply(1000));
	ws.$CarriersVDock = system.addShips("[carriers-vdock]", 1, pos, 100)[0];
	if( ws.$CarriersVDock ) {
		player.consoleMessage( ship.name+" takeoff from "+ps.displayName, 10 );
		ws.$CarriersVDock.orientation = ps.orientation; //the direction of launch
		ws.$CarriersSitInto = false;
		ws.$CarriersSitInto2 = false;
		if(ps.addCollisionException)  //from v1.81
			ps.addCollisionException(ws.$CarriersVDock);
		ws.$CarriersVDockIn = true; //timer will dock the player into vdock
		ws.$CarriersVDock.dockPlayer(); //if you comment out this line
		//continued in this.guiScreenChanged
	} else log("Carriers", "Error: can not create virtual dock for launch an escort");
}

this.$Carriers_SitIntoTheCarrier = function() {
	//add the current escort ship into the first empty item of ship storage
	var ws = worldScripts.carriers;
	var w = ws.$CarriersED;
	if( w ) {
		w.$EscortDeckSelectedPad = -1;
//		var m = worldScripts.combat_MFD;
//		if( m ) m.shipWillLaunchFromStation.bind(m); //start timer for update
		ws.$CarriersSitInto2 = true;
		var ship = player.ship;
		var b = w.$EscortDeck_MakeShipData(ship);//need to be docked
//		var b = ws.$CarriersLeavedEscortData;//w.$EscortDeck_MakeShipData(ship);
		var ps = player.ship;
		var c = null; //spawn the escort behind the player
		var pad = ws.$CarriersEDCarrierPad;
		var pos = ship.position.add(ship.heading
			.multiply(-(w.$EscortDeckLandingDist-100)));
		if( b.length > 1 && b[1].length > 0 ) //b[1] is the stored dataKey of escort
			c = system.addShips("["+b[1]+"]", 1, pos, 1000);
		if( c && c[0] && c[0].isValid ) {
			if(c[0].addCollisionException) { //from v1.81
				c[0].addCollisionException(ps);
			}
			w.$CarriersLastShip = c[0];
			w.$EscortDeck_RestoreShipData(c[0], b, w);
			w.$EscortDeck_PutShip(c[0], pad, ps, w, false, true );
		} else log("Carriers","Error: can not create escort in"
			+"$Carriers_SitIntoTheCarrier b[1]:"+b[1]+" c:"+c+" pos:"+pos);
		ws.$CarriersCarrier.remove(true); //remove the npc carrier
		ws.$Carriers_RestoreShip(ws.$CarriersShipStorage[0]);
		ws.$CarriersCarrier = ps;
	}
//	player.consoleMessage("Welcome home, Commander "+player.name+"!", 5);
//	log("Carriers", "CSITC2 Player ship:"+ps.dataKey+" "+ps.name+"/"+ps.displayName);//debug
}

this.$Carriers_StoreShip = function() {
	var ws = worldScripts.carriers;
	var sh = ws.$CarriersSH;
	if( sh ) {
		var storedShipString = sh.storeCurrentShip();
		sh.disableVortexPBNSFunc("delete");
		sh.disableMaelstromPBNSFunc("delete");
		sh.disableTCATPBNSFunc();
		return(storedShipString);
	} else log("Carriers", "Error: Carriers can not store ship without Ship Storage Helper OXP");
}

this.$Carriers_Timed = function() {
	var ps = player.ship;
	if( !ps || !ps.isValid ) return; //player died
	
	if( this.$CarriersSitInto2 ) {
		this.$CarriersSitInto = false;
		this.$CarriersSitInto2 = false;
		if(ps.docked) ps.launch(); //must leave the dock immediately to avoid safety on an open deck
		var h = worldScripts.hudselector;
		if( h ) h.$HUDSelectorRestoreHUD(); //give back the actual HUD
	}
	if( this.$CarriersVDock ) {
		if( this.$CarriersVDockIn ) {
			this.$CarriersVDockIn = false;
			if( !ps.docked ) this.$CarriersVDock.dockPlayer();
		} else {
			this.$CarriersVDock.remove(true);
			this.$CarriersVDock = null;
		}
	}

	if( this.$CarriersPlayerInEscort ) {
		var c = this.$CarriersCarrier;
		if( !c || !c.isValid ) {
			this.$CarriersPlayerInEscort = false; //if carrier died
			var w = this.$CarriersED;
			if( w ) {
				w.$EscortDeck_ControlAll( true, false, w ); //launch all
				var pad = w.$CarriersEDCarrierPad;
				w.$EscortDeckShip[pad] = null;
				w.$EscortDeckShipData[pad] = null;
				w.$CarriersEDCarrierPad = -1;
			}
		}
	}

	var m = system.mainStation; //add some NPC carriers
	if( m && m.isValid && ( !this.$CarriersShip || !this.$CarriersShip.isValid ) ) { //delayed create
		if( system.government < 5 )
			this.$CarriersPirate = system.addShipsToRoute("carriers-pirate", 1, Math.random(), "wp")[0];
		this.$CarriersShip = system.addShips("carriers-trader", 1, m.position, 150000)[0];
//		this.$CarriersShip = system.addShips("anaconda-carrier", 1, m.position, 15000)[0];//debug
//		this.$CarriersShip = system.addShips("cobra1-carrier", 1, m.position, 15000)[0];//debug
//		this.$CarriersShipRH = system.addShips("rockhermit", 1, this.$CarriersShip.position, 15000)[0];//debug
//		this.$CarriersShipRH.target = this.$CarriersShip;
//		this.$CarriersShip.target = this.$CarriersShipRH;
//		this.$CarriersShip.setAI("dockingAI.plist");
//		this.$CarriersShip = system.addShips("empty-carrier", 1, m.position, 5000)[0];//debug
//		this.$CarriersShip.setAI("nullAI.plist");//debug
		log("Carriers", "Added "+this.$CarriersShip);//debug
	}
	
	var pt = ps.target; //player is landing on carrier
	if( pt && pt.isValid && pt == this.$CarriersCarrier ) { //exclude carriers in exhibitions of Gallery OXP
		var d = ps.position.distanceTo(pt) - pt.collisionRadius;
		if( d < 25000 && pt.displayName != this.$CarriersPrevCarrier ) { //carrier within 25km
			player.consoleMessage( "Landing approved on "+pt.displayName, 10 );
			this.$CarriersPrevCarrier = pt.displayName; //save last name to avoid repeated message
		} else if( d < this.$EscortDeckLandingDist ) { //carrier within 500m
			this.$Carriers_DockPlayer( pt );
		}
	}
	
	if( this.$CarriersT && ps.viewPositionForward ) { //fix telescope visual target pos.(need 1.79)
		this.$CarriersT.$TelescopeVPos =
			ps.viewPositionForward.add(this.$CarriersT.$TelescopeVPosHUD);
	}
}
